use crate::models::train::Train;
use crate::models::{CTAResponse, Ctatt};
use serde::{Deserialize, Serialize};

#[derive(Serialize, Debug)]
pub struct RouteRequest {
    pub rt: String,
}

#[derive(Deserialize, Debug)]
pub struct Route {
    #[serde(rename = "@name")]
    pub name: String,
    pub train: Vec<Train>,
}

#[derive(Deserialize, Debug)]
pub struct RouteResp {
    #[serde(flatten)]
    pub header: Ctatt,
    #[serde(default)]
    pub route: Vec<Route>,
}

impl CTAResponse for RouteResp {
    fn get_header(&self) -> Ctatt {
        self.header.clone()
    }
}
